package com.example;

import static org.junit.jupiter.api.Assertions.*;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit.jupiter.SpringExtension;

@ExtendWith(SpringExtension.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class TransactionsApiTest {
	
	private Server server;
	private com.example.TransactionsApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@BeforeEach
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.TransactionsApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@AfterEach
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void createTest() {

		Response response = this.api.create();
		assertNotNull(response);
		com.example.model.CreateTransactionResponse result = response.readEntity(com.example.model.CreateTransactionResponse.class);
		assertNotNull(result);
	}

	@Test
	public void getTest() {
		java.lang.String transactionId = &quot;01ERZZN650QZM9N7C20E4G8760&quot;;
		java.lang.String format = &quot;json&quot;;

		Response response = this.api.get(transactionId, format);
		assertNotNull(response);
		com.example.model.Get200Response result = response.readEntity(com.example.model.Get200Response.class);
		assertNotNull(result);
	}

}
