package com.example.providers;

/**
 * A simple wrapper around {@link com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider}.
 * This declares more specific {@code @Produces} and {@code Consumes} so as to survive the
 * provider sorting changes in CXF 3.1.2 {@link http://cxf.apache.org/docs/jax-rs.html#JAX-RS-CXF3.1.2ProviderSortingChanges}.
 */
@javax.ws.rs.Produces({"application/json; charset=UTF-8", "application/*+json; charset=UTF-8" })
@javax.ws.rs.Consumes({"application/json; charset=UTF-8", "application/*+json; charset=UTF-8" })
@javax.ws.rs.ext.Provider
@javax.enterprise.context.Dependent
public class MyJaxbJsonProvider extends com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider {

	public MyJaxbJsonProvider() {
		super();

		com.fasterxml.jackson.databind.ObjectMapper jsonMapper = new com.fasterxml.jackson.databind.ObjectMapper();

		/* Support Java time object types */
		jsonMapper.registerModule(new com.fasterxml.jackson.datatype.jsr310.JavaTimeModule());
		jsonMapper.configure(com.fasterxml.jackson.databind.SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false);

		this.setMapper(jsonMapper);
	}

}
